Index: branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3864)
+++ branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3895)
@@ -28,5 +28,5 @@
    !!               Climate Dynamics, 14:101-116.
    !!  History: 
-   !!       Original.   May 2012.  (J. Simeon, G. Madec, C. Ethe, C. Calone)
+   !!       Original.   May 2012.  (J. Simeon, C. Calone, G. Madec, C. Ethe)
    !!===================================================================
 
@@ -43,9 +43,10 @@
    PRIVATE 
 
-   PUBLIC crsfun, crsfun_wgt
-   PUBLIC crs_dom_e3_max, crs_dom_sfc, crs_dom_msk, crs_dom_def, crs_dom_hgr, crs_dom_coordinates, crs_dom_bat
-
-   INTERFACE crsfun
-      MODULE PROCEDURE crsfun_UV, crsfun_TW
+   PUBLIC crs_dom_ope
+   PUBLIC crs_dom_e3_max, crs_dom_sfc, crs_dom_msk, crs_dom_hgr, crs_dom_coordinates
+   PUBLIC crs_dom_facvol, crs_dom_def, crs_dom_bat
+
+   INTERFACE crs_dom_ope
+      MODULE PROCEDURE crs_dom_ope_3d, crs_dom_ope_2d
    END INTERFACE
 
@@ -58,7 +59,7 @@
    SUBROUTINE crs_dom_msk
       
-      INTEGER  ::  ji, jj, jk, ijpk                   ! dummy loop indices
-      INTEGER  :: ijie,ijis,ijje,ijjs
-      REAL(wp) ::   zmask
+      INTEGER  ::  ji, jj, jk                   ! dummy loop indices
+      INTEGER  ::  ijie,ijis,ijje,ijjs
+      REAL(wp) ::  zmask
       
       ! Initialize
@@ -69,23 +70,23 @@
       fmask_crs(:,:,:) = 0.0
       
-      DO jk = 1, jpk
+      DO jk = 1, jpkm1
          DO ji = 2, nlei_crs  
             ijie = mie_crs(ji)
             ijis = mis_crs(ji)
-            DO jj = njstart, njend 
+            DO jj = nldj_crs, nlej_crs 
                ijje = mje_crs(jj) 
                ijjs = mjs_crs(jj) 
                                  
-               zmask = 0
+               zmask = 0.0
                zmask = SUM( tmask(ijis:ijie,ijjs:ijje,jk) ) 
-               IF ( zmask > 0 ) tmask_crs(ji,jj,jk) = 1
+               IF ( zmask > 0.0 ) tmask_crs(ji,jj,jk) = 1.0
                
-               zmask = 0
+               zmask = 0.0
                zmask = SUM( vmask(ijis:ijie,ijje     ,jk) )  
-               IF ( zmask > 0 ) vmask_crs(ji,jj,jk) = 1
+               IF ( zmask > 0.0 ) vmask_crs(ji,jj,jk) = 1.0
                
-               zmask = 0
+               zmask = 0.0
                zmask = SUM( umask(ijie     ,ijjs:ijje,jk) )  
-               IF ( zmask > 0 ) umask_crs(ji,jj,jk) = 1
+               IF ( zmask > 0.0 ) umask_crs(ji,jj,jk) = 1.0
                
                fmask_crs(ji,jj,jk) = fmask(ijie,ijje,jk)  
@@ -95,12 +96,12 @@
       ENDDO
       !
-      CALL crs_lbc_lnk( tmask_crs(:,:,:), 'T', psgn = 1.0 )
-      CALL crs_lbc_lnk( vmask_crs(:,:,:), 'V', psgn = 1.0 )
-      CALL crs_lbc_lnk( umask_crs(:,:,:), 'U', psgn = 1.0 )
-      CALL crs_lbc_lnk( fmask_crs(:,:,:), 'F', psgn = 1.0 )
+      CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
+      CALL crs_lbc_lnk( vmask_crs, 'V', 1.0 )
+      CALL crs_lbc_lnk( umask_crs, 'U', 1.0 )
+      CALL crs_lbc_lnk( fmask_crs, 'F', 1.0 )
       !
    END SUBROUTINE crs_dom_msk
 
-   SUBROUTINE crs_dom_coordinates( p_pgphi, p_pglam, cd_type, p_cgphi, p_cglam )
+   SUBROUTINE crs_dom_coordinates( p_gphi, p_glam, cd_type, p_gphi_crs, p_glam_crs )
       !!----------------------------------------------------------------
       !!               *** SUBROUTINE crs_coordinates ***
@@ -116,70 +117,90 @@
       !!               the central f-corner.
       !!
-      !! ** Input   :  p_pgphi = parent grid gphi[t|u|v|f]
-      !!               p_pglam = parent grid glam[t|u|v|f]
+      !! ** Input   :  p_gphi = parent grid gphi[t|u|v|f]
+      !!               p_glam = parent grid glam[t|u|v|f]
       !!               cd_type  = grid type (T,U,V,F)
-      !! ** Output  :  p_cgphi = coarse grid gphi[t|u|v|f]
-      !!               p_cglam = coarse grid glam[t|u|v|f]
+      !! ** Output  :  p_gphi_crs = coarse grid gphi[t|u|v|f]
+      !!               p_glam_crs = coarse grid glam[t|u|v|f]
       !!              
       !! History. 1 Jun.
       !!----------------------------------------------------------------
       !! Arguments
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: p_pgphi  ! Parent grid latitude
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: p_pglam  ! Parent grid longitude
-      CHARACTER(len=1),             INTENT(in)  :: cd_type   ! grid type (T,U,V,F) 
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs), INTENT(out) :: p_cgphi  ! Coarse grid latitude
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs), INTENT(out) :: p_cglam  ! Coarse grid longitude
+      REAL(wp), DIMENSION(jpi,jpj)        , INTENT(in)  :: p_gphi  ! Parent grid latitude
+      REAL(wp), DIMENSION(jpi,jpj)        , INTENT(in)  :: p_glam  ! Parent grid longitude
+      CHARACTER(len=1),                     INTENT(in)  :: cd_type   ! grid type (T,U,V,F) 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs), INTENT(out) :: p_gphi_crs  ! Coarse grid latitude
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs), INTENT(out) :: p_glam_crs  ! Coarse grid longitude
 
       !! Local variables
-      INTEGER ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER :: ijie,ijis,ijje,ijjs,ijpk
+      INTEGER :: ji, jj, jk                   ! dummy loop indices
+      INTEGER :: ijis, ijjs
 
   
-      !! Initialize output fields
-      p_cgphi(:,:) = 0.e0
-      p_cglam(:,:) = 0.e0
-
-       DO ji = 2, nlei_crs
-
-         IF ( cd_type == 'T' .OR. cd_type == 'V' )  ijis = mis_crs(ji) + mxbinctr 
-         IF ( cd_type == 'U' .OR. cd_type == 'F' )  ijis = mie_crs(ji)
-
-         DO jj = njstart, njend
-     
-            IF ( cd_type == 'T' .OR. cd_type == 'U' ) ijjs = mjs_crs(jj) + mybinctr                  
-            IF ( cd_type == 'V' .OR. cd_type == 'F' ) ijjs = mje_crs(jj)
-
-            p_cgphi(ji,jj) = p_pgphi(ijis,ijjs)
-            p_cglam(ji,jj) = p_pglam(ijis,ijjs)
-             
-         ENDDO
-
-      ENDDO
-
-
-       ! Retroactively add back the boundary halo cells.
-
-         CALL crs_lbc_lnk( p_cgphi(:,:),cd_type,1.0 )
-         CALL crs_lbc_lnk( p_cglam(:,:),cd_type,1.0 )
+      SELECT CASE ( cd_type )
+         CASE ( 'T' )
+            DO jj =  nldj_crs, nlej_crs
+               ijjs = mjs_crs(jj) + mybinctr
+               DO ji = 2, nlei_crs
+                  ijis = mis_crs(ji) + mxbinctr 
+                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
+                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ENDDO
+            ENDDO
+         CASE ( 'U' )
+            DO jj =  nldj_crs, nlej_crs
+               ijjs = mjs_crs(jj) + mybinctr                  
+               DO ji = 2, nlei_crs
+                  ijis = mis_crs(ji)
+                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
+                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ENDDO
+            ENDDO
+         CASE ( 'V' )
+            DO jj =  nldj_crs, nlej_crs
+               ijjs = mjs_crs(jj)
+               DO ji = 2, nlei_crs
+                  ijis = mis_crs(ji) + mxbinctr 
+                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
+                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ENDDO
+            ENDDO
+         CASE ( 'F' )
+            DO jj =  nldj_crs, nlej_crs
+               ijjs = mjs_crs(jj)
+               DO ji = 2, nlei_crs
+                  ijis = mis_crs(ji)
+                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
+                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ENDDO
+            ENDDO
+      END SELECT
+
+      ! Retroactively add back the boundary halo cells.
+      CALL crs_lbc_lnk( p_gphi_crs, cd_type, 1.0 )
+      CALL crs_lbc_lnk( p_glam_crs, cd_type, 1.0 )
          
       ! Fill up jrow=1 which is zeroed out or not handled by lbc_lnk and lbc_nfd
-
-    DO ji = 2, nlei_crs
-
-         IF ( cd_type == 'T' .OR. cd_type == 'V' )  ijis = mis_crs(ji) + mxbinctr 
-         IF ( cd_type == 'U' .OR. cd_type == 'F' )  ijis = mie_crs(ji)
-
-         p_cgphi(ji,1) = p_pgphi(ijis,1)
-         p_cglam(ji,1) = p_pglam(ijis,1)
-
-      ENDDO
-
-      ! Fill i=1, i=jpi at j=1
-      p_cgphi(1,1) = p_cgphi(jpi_crsm1,1)
-      p_cglam(1,1) = p_cglam(jpi_crsm1,1)
-      p_cgphi(jpi_crs,1) = p_cgphi(2,1)
-      p_cglam(jpi_crs,1) = p_cglam(2,1)
-      ! Fill upper-right corner i=1, j=jpj_crs
- 
+      SELECT CASE ( cd_type )
+         CASE ( 'T', 'V' )
+            DO ji = 2, nlei_crs
+               ijis = mis_crs(ji) + mxbinctr 
+               p_gphi_crs(ji,1) = p_gphi(ijis,1)
+               p_glam_crs(ji,1) = p_glam(ijis,1)
+            ENDDO
+         CASE ( 'U', 'F' )
+            DO ji = 2, nlei_crs
+               ijis = mis_crs(ji) 
+               p_gphi_crs(ji,1) = p_gphi(ijis,1)
+               p_glam_crs(ji,1) = p_glam(ijis,1)
+            ENDDO
+      END SELECT
+
+      !                                             ! Fill i=1, i=jpi at j=1
+      p_gphi_crs(1      ,1) = p_gphi(jpi_crsm1,1)
+      p_glam_crs(1      ,1) = p_glam(jpi_crsm1,1)
+      !                                             ! Fill upper-right corner i=1, j=jpj_crs
+      p_gphi_crs(jpi_crs,1) = p_gphi(2        ,1)
+      p_glam_crs(jpi_crs,1) = p_glam(2        ,1)
+      !                                            
    END SUBROUTINE crs_dom_coordinates
 
@@ -211,6 +232,6 @@
 
       !! Local variables
-      INTEGER                                 :: ji, jj, jk     ! dummy loop indices
-      INTEGER                                 :: ijie,ijis,ijje,ijjs,ijrs
+      INTEGER :: ji, jj, jk     ! dummy loop indices
+      INTEGER :: ijie,ijis,ijje,ijjs,ijrs
   
       !!----------------------------------------------------------------  
@@ -221,5 +242,5 @@
             ijie = mie_crs(ji)
             ijis = mis_crs(ji)
-            DO jj = njstart, njend
+            DO jj = nldj_crs, nlej_crs
                ijje = mje_crs(jj) 
                ijjs = mjs_crs(jj)                   
@@ -262,6 +283,5 @@
 
 
-   SUBROUTINE crsfun_wgt( cd_type, cd_op, p_pmask, p_e1, p_e2, p_fse3, &
-      &                   p_cfield2d_1, p_cfield2d_2, p_cfield3d_1, p_cfield3d_2 )
+   SUBROUTINE crs_dom_facvol( p_mask, cd_type, p_e1, p_e2, p_e3, p_fld1_crs, p_fld2_crs )
       !!----------------------------------------------------------------
       !!               *** SUBROUTINE crsfun_wgt ***
@@ -304,247 +324,125 @@
       !! 
       !!  Arguments
-      CHARACTER(len=1),                 INTENT(in) :: cd_type  ! grid type U,V 
-      CHARACTER(len=3),                 INTENT(in) :: cd_op    ! operation sum or average
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: p_pmask  ! Parent grid U,V mask
-      REAL(wp), DIMENSION(jpi,jpj),     INTENT(in) :: p_e1     ! Parent grid U,V scale factors (e1)
-      REAL(wp), DIMENSION(jpi,jpj),     INTENT(in) :: p_e2     ! Parent grid U,V scale factors (e2)
-
-      REAL(wp), DIMENSION(:,:),   INTENT(out), OPTIONAL :: p_cfield2d_1 ! Coarse grid box 2D quantity
-      REAL(wp), DIMENSION(:,:),   INTENT(out), OPTIONAL :: p_cfield2d_2 ! Coarse grid box 2D quantity
-      REAL(wp), DIMENSION(:,:,:), INTENT(out), OPTIONAL :: p_cfield3d_1 ! Coarse grid box 3D quantity 
-      REAL(wp), DIMENSION(:,:,:), INTENT(out), OPTIONAL :: p_cfield3d_2 ! Coarse grid box 3D quantity 
-
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL :: p_fse3     ! Parent grid vertical level thickness (fse3u, fse3v)
+      CHARACTER(len=1),                         INTENT(in)  :: cd_type  ! grid type U,V 
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        , INTENT(in)  :: p_mask  ! Parent grid U,V mask
+      REAL(wp), DIMENSION(jpi,jpj)            , INTENT(in)  :: p_e1     ! Parent grid U,V scale factors (e1)
+      REAL(wp), DIMENSION(jpi,jpj)            , INTENT(in)  :: p_e2     ! Parent grid U,V scale factors (e2)
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        , INTENT(in)  :: p_e3     ! Parent grid vertical level thickness (fse3u, fse3v)
+
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out) :: p_fld1_crs ! Coarse grid box 3D quantity 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out) :: p_fld2_crs ! Coarse grid box 3D quantity 
 
       !! Local variables
-      INTEGER                                 ::  ji, jj, jk, jii, jjj     ! dummy loop indices
-      INTEGER                                 :: ijie,ijis,ijje,ijjs,ijpk
-      REAL(wp)                                :: zdAm                      ! masked face area
-      REAL(wp), DIMENSION(:,:),   POINTER     :: ze1, ze2
-      REAL(wp), DIMENSION(:,:,:), POINTER     :: ze3       
-      REAL(wp), DIMENSION(:,:),   POINTER     :: zcfield2d_1, zcfield2d_2
-      REAL(wp), DIMENSION(:,:,:), POINTER     :: zcfield3d_1, zcfield3d_2
-  
+      REAL(wp)                                :: zdAm
+      INTEGER                                 :: ji, jj, jk       ! dummy loop indices
+      INTEGER                                 :: ii, ij, ijie,ijje
+
+      REAL(wp), DIMENSION(:,:,:), POINTER     :: zvol      
       !!----------------------------------------------------------------  
-      ! Initialize      
-
-      ! Arrays, scalars initialization 
-      CALL wrk_alloc(jpi    , jpj         , ze1, ze2 )
-      CALL wrk_alloc(jpi    , jpj    , jpk, ze3 )
-      CALL wrk_alloc(jpi_crs, jpj_crs,      zcfield2d_1,  zcfield2d_2 )
-      CALL wrk_alloc(jpi_crs, jpj_crs, jpk, zcfield3d_1,  zcfield3d_2 )
-
-      ze1(:,:) = 1.0
-      ze2(:,:) = 1.0
-      ze3(:,:,:) = 1.0
-      zcfield2d_1(:,:)  = 0.0
-      zcfield2d_2(:,:)  = 0.0
-      zcfield3d_1(:,:,:) = 0.0
-      zcfield3d_2(:,:,:) = 0.0
-    
-      ijpk = jpk
-
-     ! Control of arguments
-      ze1(:,:) = p_e1(:,:)
-      ze2(:,:) = p_e2(:,:)
-
-      IF ( PRESENT(p_cfield2d_1) ) p_cfield2d_1(:,:) = 0.0
-      IF ( PRESENT(p_cfield2d_2) ) p_cfield2d_2(:,:) = 0.0
-      IF ( PRESENT(p_cfield3d_1) ) p_cfield3d_1(:,:,:) = 0.0
-      IF ( PRESENT(p_cfield3d_2) ) p_cfield3d_2(:,:,:) = 0.0
-
-      IF ( PRESENT(p_fse3) ) ze3(:,:,:) = p_fse3(:,:,:)
-
-
-          DO jk = 1, ijpk    
-
-             zcfield2d_1(:,:) = 0.0 ; zcfield2d_2(:,:) = 0.0        
-            DO ji = 2, nlei_crs
-                ijie = mie_crs(ji)
-                ijis = mis_crs(ji)
-
-
-                DO jj = njstart, njend
-                   ijje = mje_crs(jj) 
-                   ijjs = mjs_crs(jj)                   
-                   
-                   IF ( cd_op == 'POS' ) THEN      !cc
-                   
-                      IF ( nn_factx == 3 .AND. nn_facty == 3) THEN
-                      
-                         SELECT CASE ( cd_type )
-                         
-                            CASE ( 'T' )
-
-                               SELECT CASE ( mje_crs(jj)-mjs_crs(jj) )
-                                     
-                                  CASE( 0, 1 )    ! Si à la frontière sud on a pas assez de maille de la grille mère
-                                      
-                                     zcfield2d_1(ji,jj) = ze1(ijie-1,ijje  ) * nn_factx
-                                     zcfield2d_2(ji,jj) = ze2(ijie-1,ijje  ) * nn_facty
-                                       
-                                  CASE DEFAULT
    
-                                     zcfield2d_1(ji,jj) = ze1(ijie-1,ijje-1) * nn_factx
-                                     zcfield2d_2(ji,jj) = ze2(ijie-1,ijje-1) * nn_facty
- 
-                                  END SELECT
-                             
-                            CASE ( 'U' )
-                            
-                               SELECT CASE ( mje_crs(jj)-mjs_crs(jj) )
-                               
-                                  CASE( 0, 1 )    ! Si à la frontière sud on a pas assez de maille de la grille mère
-                                  
-                                     zcfield2d_1(ji,jj) = ze1(ijie  ,ijje  ) * nn_factx                            
-                                     zcfield2d_2(ji,jj) = ze2(ijie  ,ijje  ) * nn_facty
-                                     
-                                  CASE DEFAULT
-                                     
-                                     zcfield2d_1(ji,jj) = ze1(ijie  ,ijje-1) * nn_factx                            
-                                     zcfield2d_2(ji,jj) = ze2(ijie  ,ijje-1) * nn_facty
-                                     
-                               END SELECT
-                                
-                            CASE ( 'V' )
-
-                               zcfield2d_1(ji,jj) = ze1(ijie-1,ijje  ) * nn_factx
-                               zcfield2d_2(ji,jj) = ze2(ijie-1,ijje  ) * nn_facty
-                                                              
-                            CASE ( 'F' )
-
-                               zcfield2d_1(ji,jj) = ze1(ijie  ,ijje  ) * nn_factx                         
-                               zcfield2d_2(ji,jj) = ze2(ijie  ,ijje  ) * nn_facty
-                               
-                         END SELECT
-                      ENDIF
-                   ENDIF                    
-                   
-
-                   IF ( cd_op == 'WGT' ) THEN
-
-                      zdAm = 0.0
-
-                      IF ( cd_type == 'V' ) THEN
-                         ! 
-                         DO jii = ijis, ijie
-                            zdAm = zdAm + ( ze1(jii,ijje) * ze3(jii,ijje,jk) * p_pmask(jii,ijje,jk) ) 
-                         ENDDO
-                         IF ( zdAm /= 0 ) zcfield3d_1(ji,jj,jk) = zdAm 
-    
-                      ELSEIF ( cd_type == 'U') THEN
-                         DO jjj = ijjs, ijje
-                            zdAm = zdAm + ( ze2(ijie,jjj) * ze3(ijie,jjj,jk) * p_pmask(ijie,jjj,jk) )
-                         ENDDO
-                         IF ( zdAm /= 0 ) zcfield3d_1(ji,jj,jk) = zdAm 
-
-                      ELSEIF ( cd_type == 'W' ) THEN
-                         DO jii = ijis, ijie
-                            DO jjj = ijjs, ijje
-                               zdAm = zdAm + ( ze1(jii,jjj) * ze2(jii,jjj) * p_pmask(jii,jjj,jk) )
-                            ENDDO
-                         ENDDO
-                         IF ( zdAm /= 0 ) zcfield3d_1(ji,jj,jk) = zdAm
-
-                      ELSEIF ( cd_type == 'T' ) THEN
-                         DO jii = ijis, ijie
-                            DO jjj = ijjs, ijje
-                               zdAm = zdAm + ( ze1(jii,jjj) * ze2(jii,jjj) * ze3(jii,jjj,jk) * p_pmask(jii,jjj,jk) )
-                            ENDDO
-                         ENDDO
-                         IF ( zdAm /= 0 ) zcfield3d_1(ji,jj,jk) = zdAm
-
-                      ELSE
-  
-                         ! jes. Add a stop?
-
-                      ENDIF
-
-                   ENDIF
-
-                   IF ( cd_op == 'VOL' ) THEN
-
-                      zdAm = 0.0
-
-                      IF ( cd_type == 'W' .OR. cd_type == 'T' ) THEN
-
-                         DO jii = ijis, ijie
-                            DO jjj = ijjs, ijje
-                               zcfield3d_1(ji,jj,jk) = zcfield3d_1(ji,jj,jk) + ( ze1(jii,jjj) * ze2(jii,jjj) * ze3(jii,jjj,jk) )
-                               zdAm = zdAm + ( ze1(jii,jjj) * ze2(jii,jjj) * ze3(jii,jjj,jk) * p_pmask(jii,jjj,jk) )
-                            ENDDO
-                         ENDDO
-                         IF ( zcfield3d_1(ji,jj,jk) /= 0 ) zcfield3d_2(ji,jj,jk) = zdAm / zcfield3d_1(ji,jj,jk)
-
-                      ELSE
-                          ! jes. add a stop?
-                      ENDIF
-
-                   ENDIF
-                                    
-                ENDDO
-             ENDDO
-
-          ENDDO
-
-! Retroactively add back the boundary halo cells.
-
-
-
-         ! Take care of the 2D arrays
-         IF ( cd_op == 'SUM' .OR.  cd_op == 'POS') THEN
-            IF ( PRESENT(p_cfield2d_1) ) THEN
-               p_cfield2d_1(:,:) = zcfield2d_1(:,:)
-               CALL crs_lbc_lnk( p_cfield2d_1(:,:),cd_type,1.0, pval=1.0)
-            ENDIF
-            
-            IF ( PRESENT(p_cfield2d_2) ) THEN
-               p_cfield2d_2(:,:) = zcfield2d_2(:,:)
-               CALL crs_lbc_lnk( p_cfield2d_2(:,:),cd_type,1.0, pval=1.0 )
-               
-               IF ( cd_op == 'SUM') THEN 
-                  DO jii = 1 , jpiglo_crs
-                  p_cfield2d_2(jii,1) = p_cfield2d_2(jii,1) * 3
-                  ENDDO
-               ENDIF
-            ENDIF
-
-         ELSE
-
-            CALL crs_lbc_lnk( zcfield2d_1(:,:),cd_type,1.0 ) 
-            IF ( PRESENT(p_cfield2d_1) ) p_cfield2d_1(:,:) = zcfield2d_1(:,:)
-            CALL crs_lbc_lnk( zcfield2d_2(:,:),cd_type,1.0 ) 
-            IF ( PRESENT(p_cfield2d_2) ) p_cfield2d_2(:,:) = zcfield2d_2(:,:)
-
-         ENDIF
-
-         ! Take care now of 3d arrays
-         IF ( cd_op == 'SUM' .OR. cd_op == 'VOL' .OR. cd_op == 'POS'  ) THEN
-            CALL crs_lbc_lnk( zcfield3d_1(:,:,:),cd_type,1.0 ) 
-            IF ( PRESENT(p_cfield3d_1) ) p_cfield3d_1(:,:,:) = zcfield3d_1(:,:,:)
-            CALL crs_lbc_lnk( zcfield3d_2(:,:,:),cd_type,1.0 ) 
-            IF ( PRESENT(p_cfield3d_2) ) p_cfield3d_2(:,:,:) = zcfield3d_2(:,:,:)
-         ELSE
-            p_cfield3d_1(:,:,:) = zcfield3d_1(:,:,:)
-            CALL crs_lbc_lnk( p_cfield3d_1(:,:,:),cd_type,1.0 )
-
-            ! Fill upper-right corner i=1, j=jpj_crs
-            IF ( nperio == 4 ) THEN
-               p_cfield3d_1(1,jpj_crs,:) = p_cfield3d_1(jpi_crsm1,jpj_crs-2,:)
-            ELSEIF ( nperio == 6 ) THEN
-               p_cfield3d_1(1,jpj_crs,:) = p_cfield3d_1(jpi_crs,jpj_crsm1,:)
-            ENDIF
-
-         ENDIF
-
-      CALL wrk_dealloc(jpi    , jpj         , ze1, ze2 )
-      CALL wrk_dealloc(jpi    , jpj    , jpk, ze3 )
-      CALL wrk_dealloc(jpi_crs, jpj_crs,      zcfield2d_1,  zcfield2d_2 )
-      CALL wrk_dealloc(jpi_crs, jpj_crs, jpk, zcfield3d_1,  zcfield3d_2 )
-
-   END SUBROUTINE crsfun_wgt
-
-
-   SUBROUTINE crsfun_UV( p_e1_e2, cd_type, psgn, p_pmask, p_fse3, p_pfield, p_surf_crs, p_cfield3d )
+      CALL wrk_alloc( jpi, jpj, jpk, zvol )
+
+      DO jk = 1, jpk
+         zvol(:,:,jk) =  p_e1(:,:) * p_e2(:,:) * p_e3(:,:,jk) 
+      ENDDO
+
+      DO jk = 1, jpk           
+         DO ji = nistr, niend, nn_factx
+            DO jj   = njstr, njend, nn_facty
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+               ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+               ijje = mje_crs(ij)
+               ijie = mie_crs(ii)
+               !
+               p_fld1_crs(ii,ij,jk) =  zvol(ji,jj  ,jk) + zvol(ji+1,jj  ,jk) + zvol(ji+2,jj  ,jk)  &
+                   &                 + zvol(ji,jj+1,jk) + zvol(ji+1,jj+1,jk) + zvol(ji+2,jj+1,jk)  &
+                   &                 + zvol(ji,jj+2,jk) + zvol(ji+1,jj+2,jk) + zvol(ji+2,jj+2,jk)  
+            ENDDO
+         ENDDO
+      ENDDO
+
+      IF( cd_type == 'T' ) THEN
+         DO jk = 1, jpk           
+            DO ji = nistr, niend, nn_factx
+               DO jj   = njstr, njend, nn_facty
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                  ijje = mje_crs(ij)
+                  ijie = mie_crs(ii)
+                  !
+                  zdAm =  zvol(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk)  &
+                    &   + zvol(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk)  &
+                    &   + zvol(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk)  &
+                    &   + zvol(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk)  &
+                    &   + zvol(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk)  &
+                    &   + zvol(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk)  &
+                    &   + zvol(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk)  &
+                    &   + zvol(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk)  &
+                    &   + zvol(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk)
+                    ! 
+                   IF( p_fld1_crs(ii,ij,jk) /= 0._wp ) p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
+                   ! 
+               ENDDO
+            ENDDO
+         ENDDO
+      ENDIF
+      !
+      IF( cd_type == 'W' ) THEN
+         DO jk = 2, jpk           
+            DO ji = nistr, niend, nn_factx
+               DO jj   = njstr, njend, nn_facty
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                  ijje = mje_crs(ij)
+                  ijie = mie_crs(ii)
+                  !
+                  zdAm =  zvol(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1)  &
+                    &   + zvol(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1)  &
+                    &   + zvol(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1)  &
+                    &   + zvol(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1)  &
+                    &   + zvol(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1)  &
+                    &   + zvol(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1)  &
+                    &   + zvol(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1)  &
+                    &   + zvol(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1)  &
+                    &   + zvol(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1)
+                  !
+                  IF( p_fld1_crs(ii,ij,jk) /= 0._wp ) p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
+                  !
+               ENDDO
+            ENDDO
+         ENDDO
+         DO ji = nistr, niend, nn_factx
+            DO jj   = njstr, njend, nn_facty
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+               ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+               ijje = mje_crs(ij)
+               ijie = mie_crs(ii)
+               !
+               zdAm =  zvol(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1)  &
+                 &   + zvol(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1)  &
+                 &   + zvol(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1)  &
+                 &   + zvol(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1)  &
+                 &   + zvol(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1)  &
+                 &   + zvol(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1)  &
+                 &   + zvol(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1)  &
+                 &   + zvol(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1)  &
+                 &   + zvol(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1)
+               ! 
+               IF( p_fld1_crs(ii,ij,1) /= 0._wp ) p_fld2_crs(ii,ij,1) = zdAm / p_fld2_crs(ii,ij,1) 
+               ! 
+            ENDDO
+         ENDDO
+      ENDIF
+      
+      !                                             !  Retroactively add back the boundary halo cells.
+      CALL crs_lbc_lnk( p_fld1_crs, cd_type, 1.0 ) 
+      CALL crs_lbc_lnk( p_fld2_crs, cd_type, 1.0 ) 
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zvol )
+      !
+   END SUBROUTINE crs_dom_facvol
+
+
+   SUBROUTINE crs_dom_ope_3d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs )
       !!----------------------------------------------------------------
       !!               *** SUBROUTINE crsfun_UV ***
